diff --git a/headers/build/posix/string.h b/headers/build/posix/string.h
new file mode 100644
index 0000000..fd9d9da
--- /dev/null
+++ b/headers/build/posix/string.h
@@ -0,0 +1,62 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_STRING_H
+#define _HAIKU_BUILD_STRING_H
+
+
+#include <stddef.h>
+
+#include <HaikuBuild.h>
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+
+_HAIKU_BUILD_DECLARE_FUNCTION(
+	size_t, strlcpy, (char* dest, const char* source, size_t length))
+_HAIKU_BUILD_DECLARE_FUNCTION(
+	size_t, strlcat, (char* dest, const char* source, size_t length))
+_HAIKU_BUILD_DECLARE_FUNCTION(
+	char*, stpcpy, (char* dest, const char* source))
+_HAIKU_BUILD_DECLARE_FUNCTION(
+	size_t, strnlen, (const char* string, size_t count))
+_HAIKU_BUILD_DECLARE_FUNCTION(
+	char*, strcasestr, (const char* string, const char* searchString))
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+
+#include_next <string.h>
+
+#ifndef _HAIKU_HOST_FEATURE_strlcpy
+size_t	strlcpy(char* dest, const char* source, size_t length);
+#endif
+
+#ifndef _HAIKU_HOST_FEATURE_strlcat
+size_t	strlcat(char* dest, const char* source, size_t length);
+#endif
+
+#ifndef _HAIKU_HOST_FEATURE_stpcpy
+char*	stpcpy(char* dest, const char* source);
+#endif
+
+#ifndef _HAIKU_HOST_FEATURE_strnlen
+size_t	strnlen(const char* string, size_t count);
+#endif
+
+#ifndef _HAIKU_HOST_FEATURE_strcasestr
+char*	strcasestr(const char* string, const char* searchString);
+#endif
+
+#endif	// _HAIKU_BUILD_BUILD_LIBROOT
+
+
+#ifdef __cplusplus
+} /* extern "C" */
+#endif
+
+#endif	/* _HAIKU_BUILD_STRING_H */
diff --git a/headers/build/posix/strings.h b/headers/build/posix/strings.h
new file mode 100644
index 0000000..14dd2b9
--- /dev/null
+++ b/headers/build/posix/strings.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_STRINGS_H
+#define _HAIKU_BUILD_STRINGS_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <strings.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_STRINGS_H */
diff --git a/headers/build/posix/sys/cdefs.h b/headers/build/posix/sys/cdefs.h
new file mode 100644
index 0000000..8e32475
--- /dev/null
+++ b/headers/build/posix/sys/cdefs.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_CDEFS_H
+#define _HAIKU_BUILD_SYS_CDEFS_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/cdefs.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_CDEFS_H */
diff --git a/headers/build/posix/sys/file.h b/headers/build/posix/sys/file.h
new file mode 100644
index 0000000..e429b15
--- /dev/null
+++ b/headers/build/posix/sys/file.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_FILE_H
+#define _HAIKU_BUILD_SYS_FILE_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/file.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_FILE_H */
diff --git a/headers/build/posix/sys/ioctl.h b/headers/build/posix/sys/ioctl.h
new file mode 100644
index 0000000..043cd77
--- /dev/null
+++ b/headers/build/posix/sys/ioctl.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_IOCTL_H
+#define _HAIKU_BUILD_SYS_IOCTL_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/ioctl.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_IOCTL_H */
diff --git a/headers/build/posix/sys/ipc.h b/headers/build/posix/sys/ipc.h
new file mode 100644
index 0000000..409ce5a
--- /dev/null
+++ b/headers/build/posix/sys/ipc.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_IPC_H
+#define _HAIKU_BUILD_SYS_IPC_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/ipc.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_IPC_H */
diff --git a/headers/build/posix/sys/mman.h b/headers/build/posix/sys/mman.h
new file mode 100644
index 0000000..7f8e0d1
--- /dev/null
+++ b/headers/build/posix/sys/mman.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_MMAN_H
+#define _HAIKU_BUILD_SYS_MMAN_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/mman.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_MMAN_H */
diff --git a/headers/build/posix/sys/msg.h b/headers/build/posix/sys/msg.h
new file mode 100644
index 0000000..c0b21e9
--- /dev/null
+++ b/headers/build/posix/sys/msg.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_MSG_H
+#define _HAIKU_BUILD_SYS_MSG_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/msg.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_MSG_H */
diff --git a/headers/build/posix/sys/param.h b/headers/build/posix/sys/param.h
new file mode 100644
index 0000000..851ec20
--- /dev/null
+++ b/headers/build/posix/sys/param.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_PARAM_H
+#define _HAIKU_BUILD_SYS_PARAM_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/param.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_PARAM_H */
diff --git a/headers/build/posix/sys/poll.h b/headers/build/posix/sys/poll.h
new file mode 100644
index 0000000..25fd807
--- /dev/null
+++ b/headers/build/posix/sys/poll.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_POLL_H
+#define _HAIKU_BUILD_SYS_POLL_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/poll.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_POLL_H */
diff --git a/headers/build/posix/sys/resource.h b/headers/build/posix/sys/resource.h
new file mode 100644
index 0000000..474f8bb
--- /dev/null
+++ b/headers/build/posix/sys/resource.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_RESOURCE_H
+#define _HAIKU_BUILD_SYS_RESOURCE_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/resource.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_RESOURCE_H */
diff --git a/headers/build/posix/sys/select.h b/headers/build/posix/sys/select.h
new file mode 100644
index 0000000..aeebaea
--- /dev/null
+++ b/headers/build/posix/sys/select.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_SELECT_H
+#define _HAIKU_BUILD_SYS_SELECT_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/select.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_SELECT_H */
diff --git a/headers/build/posix/sys/sem.h b/headers/build/posix/sys/sem.h
new file mode 100644
index 0000000..522b504
--- /dev/null
+++ b/headers/build/posix/sys/sem.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_SEM_H
+#define _HAIKU_BUILD_SYS_SEM_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/sem.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_SEM_H */
diff --git a/headers/build/posix/sys/socket.h b/headers/build/posix/sys/socket.h
new file mode 100644
index 0000000..3b10f2b
--- /dev/null
+++ b/headers/build/posix/sys/socket.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_SOCKET_H
+#define _HAIKU_BUILD_SYS_SOCKET_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/socket.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_SOCKET_H */
diff --git a/headers/build/posix/sys/sockio.h b/headers/build/posix/sys/sockio.h
new file mode 100644
index 0000000..26f63d6
--- /dev/null
+++ b/headers/build/posix/sys/sockio.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_SOCKIO_H
+#define _HAIKU_BUILD_SYS_SOCKIO_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/sockio.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_SOCKIO_H */
diff --git a/headers/build/posix/sys/stat.h b/headers/build/posix/sys/stat.h
new file mode 100644
index 0000000..d3394a9
--- /dev/null
+++ b/headers/build/posix/sys/stat.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_STAT_H
+#define _HAIKU_BUILD_SYS_STAT_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/stat.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_STAT_H */
diff --git a/headers/build/posix/sys/statvfs.h b/headers/build/posix/sys/statvfs.h
new file mode 100644
index 0000000..36e6509
--- /dev/null
+++ b/headers/build/posix/sys/statvfs.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_STATVFS_H
+#define _HAIKU_BUILD_SYS_STATVFS_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/statvfs.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_STATVFS_H */
diff --git a/headers/build/posix/sys/time.h b/headers/build/posix/sys/time.h
new file mode 100644
index 0000000..149ba30
--- /dev/null
+++ b/headers/build/posix/sys/time.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_TIME_H
+#define _HAIKU_BUILD_SYS_TIME_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/time.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_TIME_H */
diff --git a/headers/build/posix/sys/timeb.h b/headers/build/posix/sys/timeb.h
new file mode 100644
index 0000000..f0613a2
--- /dev/null
+++ b/headers/build/posix/sys/timeb.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_TIMEB_H
+#define _HAIKU_BUILD_SYS_TIMEB_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/timeb.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_TIMEB_H */
diff --git a/headers/build/posix/sys/times.h b/headers/build/posix/sys/times.h
new file mode 100644
index 0000000..af6c9c6
--- /dev/null
+++ b/headers/build/posix/sys/times.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_TIMES_H
+#define _HAIKU_BUILD_SYS_TIMES_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/times.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_TIMES_H */
diff --git a/headers/build/posix/sys/types.h b/headers/build/posix/sys/types.h
new file mode 100644
index 0000000..fc37830
--- /dev/null
+++ b/headers/build/posix/sys/types.h
@@ -0,0 +1,129 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_TYPES_H
+#define _HAIKU_BUILD_SYS_TYPES_H
+
+
+#include <config_build/types.h>
+
+#include <BeBuild.h>
+
+
+/* BSD compatibility */
+typedef unsigned long 		haiku_build_u_long;
+typedef unsigned int 		haiku_build_u_int;
+typedef unsigned short 		haiku_build_u_short;
+typedef unsigned char 		haiku_build_u_char;
+
+
+/* sysV compatibility */
+typedef unsigned long 		haiku_build_ulong;
+typedef unsigned short 		haiku_build_ushort;
+typedef unsigned int 		haiku_build_uint;
+typedef unsigned char		haiku_build_unchar;
+
+
+typedef __haiku_build_haiku_int64 		haiku_build_blkcnt_t;
+typedef __haiku_build_haiku_std_int32	haiku_build_blksize_t;
+typedef __haiku_build_haiku_int64		haiku_build_fsblkcnt_t;
+typedef __haiku_build_haiku_int64		haiku_build_fsfilcnt_t;
+typedef __haiku_build_haiku_int64		haiku_build_off_t;
+typedef __haiku_build_haiku_int64		haiku_build_ino_t;
+typedef __haiku_build_haiku_std_int32	haiku_build_cnt_t;
+typedef __haiku_build_haiku_int32		haiku_build_dev_t;
+typedef __haiku_build_haiku_int32		haiku_build_pid_t;
+typedef __haiku_build_haiku_int32		haiku_build_id_t;
+
+typedef __haiku_build_haiku_std_uint32	haiku_build_uid_t;
+typedef __haiku_build_haiku_std_uint32	haiku_build_gid_t;
+typedef __haiku_build_haiku_std_uint32  haiku_build_mode_t;
+typedef __haiku_build_haiku_std_uint32	haiku_build_umode_t;
+typedef __haiku_build_haiku_std_int32	haiku_build_nlink_t;
+
+#ifdef __HAIKU_BEOS_COMPATIBLE_TYPES
+	typedef int		haiku_build_daddr_t;	/* disk address */
+#else
+	typedef haiku_build_off_t	haiku_build_daddr_t;	/* disk address */
+#endif
+typedef char*				haiku_build_caddr_t;
+
+typedef __haiku_build_haiku_addr_t		haiku_build_addr_t;
+typedef __haiku_build_haiku_int32 		haiku_build_key_t;
+
+typedef __haiku_build_haiku_std_int32	haiku_build_clockid_t;
+typedef struct __haiku_build_timer_t*	haiku_build_timer_t;
+
+
+/* pthread types */
+
+typedef struct	_haiku_build_pthread_thread		*haiku_build_pthread_t;
+typedef struct  _haiku_build_pthread_attr		*haiku_build_pthread_attr_t;
+typedef struct  _haiku_build_pthread_mutex		haiku_build_pthread_mutex_t;
+typedef struct  _haiku_build_pthread_mutexattr	*haiku_build_pthread_mutexattr_t;
+typedef struct  _haiku_build_pthread_cond		haiku_build_pthread_cond_t;
+typedef struct  _haiku_build_pthread_condattr	*haiku_build_pthread_condattr_t;
+typedef int							haiku_build_pthread_key_t;
+typedef struct  _haiku_build_pthread_once		haiku_build_pthread_once_t;
+typedef struct  _haiku_build_pthread_rwlock		haiku_build_pthread_rwlock_t;
+typedef struct  _haiku_build_pthread_rwlockattr	*haiku_build_pthread_rwlockattr_t;
+typedef struct  _haiku_build_pthread_spinlock	haiku_build_pthread_spinlock_t;
+/*
+typedef struct  _haiku_build_pthread_barrier	*haiku_build_pthread_barrier_t;
+typedef struct  _haiku_build_pthread_barrierattr *haiku_build_pthread_barrierattr_t;
+*/
+
+struct _haiku_build_pthread_mutex {
+	__haiku_build_haiku_std_uint32	flags;
+	__haiku_build_haiku_std_int32	lock;
+	__haiku_build_haiku_std_int32	unused;
+	__haiku_build_haiku_std_int32	owner;
+	__haiku_build_haiku_std_int32	owner_count;
+};
+
+struct _haiku_build_pthread_cond {
+	__haiku_build_haiku_std_uint32	flags;
+	__haiku_build_haiku_std_int32	unused;
+	haiku_build_pthread_mutex_t*	mutex;
+	__haiku_build_haiku_std_int32	waiter_count;
+	__haiku_build_haiku_std_int32	lock;
+};
+
+struct _haiku_build_pthread_once {
+	__haiku_build_haiku_std_int32	state;
+};
+
+struct _haiku_build_pthread_rwlock {
+	__haiku_build_haiku_std_uint32	flags;
+	__haiku_build_haiku_std_int32	owner;
+	union {
+		struct {
+			__haiku_build_haiku_std_int32	sem;
+		} shared;
+		struct {
+			__haiku_build_haiku_std_int32	lock_sem;
+			__haiku_build_haiku_std_int32	lock_count;
+			__haiku_build_haiku_std_int32	reader_count;
+			__haiku_build_haiku_std_int32	writer_count;
+			void*				waiters[2];
+		} local;
+	} u;
+};
+
+struct _haiku_build_pthread_spinlock {
+	__haiku_build_haiku_std_int32		lock;
+};
+
+
+#include <null.h>
+#include <size_t.h>
+#include <time.h>
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/types.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_TYPES_H */
diff --git a/headers/build/posix/sys/uio.h b/headers/build/posix/sys/uio.h
new file mode 100644
index 0000000..5a62d0f
--- /dev/null
+++ b/headers/build/posix/sys/uio.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_UIO_H
+#define _HAIKU_BUILD_SYS_UIO_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/uio.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_UIO_H */
diff --git a/headers/build/posix/sys/un.h b/headers/build/posix/sys/un.h
new file mode 100644
index 0000000..e174ed8
--- /dev/null
+++ b/headers/build/posix/sys/un.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_UN_H
+#define _HAIKU_BUILD_SYS_UN_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/un.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_UN_H */
diff --git a/headers/build/posix/sys/utsname.h b/headers/build/posix/sys/utsname.h
new file mode 100644
index 0000000..b44f3ab
--- /dev/null
+++ b/headers/build/posix/sys/utsname.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_UTSNAME_H
+#define _HAIKU_BUILD_SYS_UTSNAME_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/utsname.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_UTSNAME_H */
diff --git a/headers/build/posix/sys/wait.h b/headers/build/posix/sys/wait.h
new file mode 100644
index 0000000..e2dfc6d
--- /dev/null
+++ b/headers/build/posix/sys/wait.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYS_WAIT_H
+#define _HAIKU_BUILD_SYS_WAIT_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sys/wait.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYS_WAIT_H */
diff --git a/headers/build/posix/syslog.h b/headers/build/posix/syslog.h
new file mode 100644
index 0000000..b071c7c
--- /dev/null
+++ b/headers/build/posix/syslog.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SYSLOG_H
+#define _HAIKU_BUILD_SYSLOG_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <syslog.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SYSLOG_H */
diff --git a/headers/build/posix/termios.h b/headers/build/posix/termios.h
new file mode 100644
index 0000000..c06fc8d
--- /dev/null
+++ b/headers/build/posix/termios.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_TERMIOS_H
+#define _HAIKU_BUILD_TERMIOS_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <termios.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_TERMIOS_H */
diff --git a/headers/build/posix/time.h b/headers/build/posix/time.h
new file mode 100644
index 0000000..57ace36
--- /dev/null
+++ b/headers/build/posix/time.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_TIME_H
+#define _HAIKU_BUILD_TIME_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <time.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_TIME_H */
diff --git a/headers/build/posix/unistd.h b/headers/build/posix/unistd.h
new file mode 100644
index 0000000..8f97986
--- /dev/null
+++ b/headers/build/posix/unistd.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_UNISTD_H
+#define _HAIKU_BUILD_UNISTD_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <unistd.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_UNISTD_H */
diff --git a/headers/build/posix/utime.h b/headers/build/posix/utime.h
new file mode 100644
index 0000000..a198496
--- /dev/null
+++ b/headers/build/posix/utime.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_UTIME_H
+#define _HAIKU_BUILD_UTIME_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <utime.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_UTIME_H */
diff --git a/headers/build/posix/wchar.h b/headers/build/posix/wchar.h
new file mode 100644
index 0000000..2c03351
--- /dev/null
+++ b/headers/build/posix/wchar.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_WCHAR_H
+#define _HAIKU_BUILD_WCHAR_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <wchar.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_WCHAR_H */
diff --git a/headers/build/posix/wchar_t.h b/headers/build/posix/wchar_t.h
new file mode 100644
index 0000000..ebd111d
--- /dev/null
+++ b/headers/build/posix/wchar_t.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_WCHAR_T_H
+#define _HAIKU_BUILD_WCHAR_T_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <wchar_t.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_WCHAR_T_H */
diff --git a/headers/build/posix/wctype.h b/headers/build/posix/wctype.h
new file mode 100644
index 0000000..200a60e
--- /dev/null
+++ b/headers/build/posix/wctype.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_WCTYPE_H
+#define _HAIKU_BUILD_WCTYPE_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <wctype.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_WCTYPE_H */
diff --git a/src/build/Jamfile b/src/build/Jamfile
index 17634b0..3b7aa4c 100644
--- a/src/build/Jamfile
+++ b/src/build/Jamfile
@@ -1,5 +1,6 @@
 SubDir HAIKU_TOP src build ;
 
+SubInclude HAIKU_TOP src build configure ;
 SubInclude HAIKU_TOP src build libbe ;
 SubInclude HAIKU_TOP src build libhaikucompat ;
 SubInclude HAIKU_TOP src build libpackage ;
diff --git a/src/build/configure/Jamfile b/src/build/configure/Jamfile
new file mode 100644
index 0000000..ea888d5
--- /dev/null
+++ b/src/build/configure/Jamfile
@@ -0,0 +1,118 @@
+SubDir HAIKU_TOP src build configure ;
+
+HAIKU_BUILD_HOST_FEATURES = <build!configure>HostFeatures ;
+MakeLocate $(HAIKU_BUILD_HOST_FEATURES) : $(HAIKU_BUILD_OUTPUT_DIR) ;
+
+HAIKU_BUILD_CONFIG_HEADER = <build!configure>HaikuHostBuildConfig.h ;
+MakeLocate $(HAIKU_BUILD_CONFIG_HEADER) : $(HAIKU_BUILD_OUTPUT_DIR) ;
+
+local configureTargets ;
+
+rule ConfigureCheckExists feature : fileTarget
+{
+	local target = $(fileTarget:G=build!configure!test) ;
+
+	FEATURE on $(target) = $(feature) ;
+	NotFile $(target) ;
+	Depends $(target) : $(HAIKU_BUILD_CONFIG_HEADER) $(fileTarget) ;
+
+	ConfigureCheckExists1 $(target)
+		: $(HAIKU_BUILD_CONFIG_HEADER) $(fileTarget) ;
+
+	configureTargets += $(target) ;
+}
+
+
+actions ConfigureCheckExists1
+{
+	if [ -f "$(2[2-])" ]; then
+		echo "#define _HAIKU_BUILD_FEATURE_$(FEATURE) 1" >> $(2[1])
+#		echo $(FEATURE) >> $(2[1])
+	fi
+}
+
+
+rule ConfigureTestCompile feature : sources : libraries
+{
+	local executable = <build!configure>test_$(feature) ;
+
+	BuildPlatformMain $(executable) : $(sources) : $(libraries) ;
+	ConfigureCheckExists $(feature) : $(executable) ;
+}
+
+
+rule ConfigureCheckFunction function : code : headers : libraries
+{
+	local source = [ FGristFiles test_$(function).cpp ] ;
+	CODE on $(source) = $(code) ;
+	HEADERS on $(source) = $(headers) ;
+
+	MakeLocateCommonPlatform $(source) ;
+	ConfigureCheckFunction1 $(source) ;
+
+	ConfigureTestCompile $(function) : $(source) : $(libraries) ;
+}
+
+
+actions ConfigureCheckFunction1
+{
+	rm -f $(1)
+	for header in $(HEADERS); do
+		echo "#include <$header>" >> $(1)
+	done
+
+	cat << EOF >> $(1)
+		int main()
+		{
+			$(CODE)
+			return 0;
+		}
+	EOF
+}
+
+
+rule ConfigureRunProgram name : sources : libraries
+{
+	local program = $(name:G=build!configure) ;
+	local target = $(name:G=build!configure!test) ;
+
+	BuildPlatformMain $(program) : $(sources) : $(libraries) ;
+
+	ConfigureRunProgram1 ;
+
+	NotFile $(target) ;
+	Depends $(target) : $(HAIKU_BUILD_CONFIG_HEADER) $(program) ;
+
+	ConfigureRunProgram1 $(target) : $(HAIKU_BUILD_CONFIG_HEADER) $(program) ;
+
+	configureTargets += $(target) ;
+}
+
+
+actions ConfigureRunProgram1
+{
+	$(2[2-]) >> $(2[1])
+}
+
+
+ConfigureCheckFunction strnlen
+	: "(void)strnlen(\"test\", 4);"
+	: string.h ;
+
+ConfigureCheckFunction strlcpy
+	: "char buffer[10]; strlcpy(buffer, \"test\", sizeof(buffer));"
+	: string.h ;
+
+ConfigureCheckFunction stpcpy
+	: "char buffer[10]; stpcpy(buffer, \"test\");"
+	: string.h ;
+
+ConfigureCheckFunction strcasestr
+	: "(void)strcasestr(\"foo\", \"bar\");"
+	: string.h ;
+
+ConfigureRunProgram test_int_types : test_int_types.cpp ;
+
+
+Depends configure_build : $(configureTargets) ;
+NotFile configure_build ;
diff --git a/src/build/configure/test_int_types.cpp b/src/build/configure/test_int_types.cpp
new file mode 100644
index 0000000..6937c2b
--- /dev/null
+++ b/src/build/configure/test_int_types.cpp
@@ -0,0 +1,71 @@
+/*
+ * Copyright 2011, Ingo Weinhold, ingo_weinhold@gmx.de.
+ * Distributed under the terms of the MIT License.
+ */
+
+
+#include <inttypes.h>
+#include <stdio.h>
+
+
+template<typename Type>
+struct TypeInfo {
+	static const char* const TypeName();
+	static const char* const Prefix();
+};
+
+
+#define DEFINE_TYPE_INFO_TEMPLATE(type, prefix)	\
+	template<>									\
+	struct TypeInfo<type> {						\
+		static const char* const TypeName()		\
+		{										\
+			return #type;						\
+		}										\
+		static const char* const Prefix()		\
+		{										\
+			return prefix;						\
+		}										\
+	};
+
+#define DEFINE_TYPE_INFO_TEMPLATE_SIGNED_AND_UNSIGNED(type, prefix)	\
+	DEFINE_TYPE_INFO_TEMPLATE(type, prefix)							\
+	DEFINE_TYPE_INFO_TEMPLATE(unsigned type, prefix)
+
+
+DEFINE_TYPE_INFO_TEMPLATE_SIGNED_AND_UNSIGNED(char, "")
+DEFINE_TYPE_INFO_TEMPLATE(signed char, "")
+DEFINE_TYPE_INFO_TEMPLATE_SIGNED_AND_UNSIGNED(short, "")
+DEFINE_TYPE_INFO_TEMPLATE_SIGNED_AND_UNSIGNED(int, "")
+DEFINE_TYPE_INFO_TEMPLATE_SIGNED_AND_UNSIGNED(long, "l")
+DEFINE_TYPE_INFO_TEMPLATE_SIGNED_AND_UNSIGNED(long long, "ll")
+
+
+template<typename Type>
+struct PrintTypeInfo {
+	static void Print(const char* name)
+	{
+		printf("#define _HAIKU_BUILD_FEATURE_%s %s\n", name,
+			TypeInfo<Type>::TypeName());
+		printf("#define _HAIKU_BUILD_FEATURE_FORMAT_PREFIX_%s \"%s\"\n", name,
+			TypeInfo<Type>::Prefix());
+	}
+};
+
+
+#define PRINT_TYPE_INFO(type)	PrintTypeInfo<type##_t>::Print(#type)
+
+#define PRINT_TYPE_INFO_SIGNED_AND_UNSIGNED(type)	\
+	PRINT_TYPE_INFO(type);							\
+	PRINT_TYPE_INFO(u##type)
+
+
+int
+main()
+{
+	PRINT_TYPE_INFO_SIGNED_AND_UNSIGNED(int8);
+	PRINT_TYPE_INFO_SIGNED_AND_UNSIGNED(int16);
+	PRINT_TYPE_INFO_SIGNED_AND_UNSIGNED(int32);
+	PRINT_TYPE_INFO_SIGNED_AND_UNSIGNED(int64);
+	return 0;
+}
diff --git a/src/build/libroot/Jamfile b/src/build/libroot/Jamfile
index e1ebd9d..99430ce 100644
--- a/src/build/libroot/Jamfile
+++ b/src/build/libroot/Jamfile
@@ -1,16 +1,20 @@
 SubDir HAIKU_TOP src build libroot ;
 
-UseHeaders [ FDirName $(HAIKU_TOP) headers build ] : true ;
-UseHeaders [ FDirName $(HAIKU_TOP) headers build os ] : true ;
-UseHeaders [ FDirName $(HAIKU_TOP) headers build os app ] : true ;
-UseHeaders [ FDirName $(HAIKU_TOP) headers build os drivers ] : true ;
-UseHeaders [ FDirName $(HAIKU_TOP) headers build os kernel ] : true ;
-UseHeaders [ FDirName $(HAIKU_TOP) headers build os interface ] : true ;
-UseHeaders [ FDirName $(HAIKU_TOP) headers build os storage ] : true ;
-UseHeaders [ FDirName $(HAIKU_TOP) headers build os support ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build os ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build os app ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build os drivers ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build os kernel ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build os interface ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build os storage ] : true ;
+# UseHeaders [ FDirName $(HAIKU_TOP) headers build os support ] : true ;
+UseHeaders $(HOST_BE_API_HEADERS) : true ;
 
 UsePrivateBuildHeaders kernel system ;
 
+#DEFINES += _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER=1 ;
+
 {
 	local defines = [ FDefines
 		HAIKU_BUILD_ATTRIBUTES_DIR="\\\"$(HAIKU_BUILD_ATTRIBUTES_DIR)\\\""
@@ -30,19 +34,20 @@ UsePrivateBuildHeaders kernel system ;
 	defines = [ FDefines KMESSAGE_CONTAINER_ONLY=1 ] ;
 	ObjectC++Flags KMessage.cpp : $(defines) ;
 
+	defines = [ FDefines _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER=1 ] ;
+	ObjectC++Flags atomic.cpp : $(defines) ;
 }
 
 # locate the library
 MakeLocate libroot_build.so : $(HOST_BUILD_COMPATIBILITY_LIB_DIR) ;
 
-# darwin already has strlcpy and strlcat in libSystem
+# add string functions not provided by the host platform
 local strlSources ;
-if $(HOST_PLATFORM) != darwin {
-	strlSources = strlcpy.c strlcat.c ;
-}
-
-if $(HOST_PLATFORM) = cygwin || $(HOST_PLATFORM) = sunos {
-	strlSources += stpcpy.c strcasestr.c ;
+local function ;
+for function in strlcpy strlcat stpcpy strcasestr strnlen {
+	if $(HAIKU_HOST_FEATURE_$(function)) != 1 {
+		strlSources = $(function).c ;
+	}
 }
 
 local hostPlatformSources ;
@@ -53,7 +58,7 @@ if $(HOST_PLATFORM) = freebsd {
 local librootSources =
 	atomic.cpp
 	byteorder.cpp
-	errors.cpp
+#	errors.cpp
 	find_directory.cpp
 	fs.cpp
 	fs_attr.cpp
@@ -67,12 +72,11 @@ local librootSources =
 	driver_settings.cpp
 
 	$(strlSources)
-	strnlen.c
 
 	KMessage.cpp
 ;
 
-USES_BE_API on [ FGristFiles $(librootSources:S=$(SUFOBJ)) ] = true ;
+#USES_BE_API on [ FGristFiles $(librootSources:S=$(SUFOBJ)) ] = true ;
 
 BuildPlatformSharedLibrary libroot_build.so :
 	$(librootSources)
@@ -85,7 +89,7 @@ BuildPlatformStaticLibrary libroot_build.a :
 	[ FGristFiles $(librootSources:S=$(SUFOBJ)) ]
 ;
 
-USES_BE_API on [ FGristFiles function_remapper$(SUFOBJ) ] = true ;
+#USES_BE_API on [ FGristFiles function_remapper$(SUFOBJ) ] = true ;
 
 BuildPlatformStaticLibraryPIC libroot_build_function_remapper.a :
 	function_remapper.cpp
@@ -93,7 +97,7 @@ BuildPlatformStaticLibraryPIC libroot_build_function_remapper.a :
 
 SEARCH on [ FGristFiles driver_settings.cpp ]
 	= [ FDirName $(HAIKU_TOP) src system libroot os ] ;
-SEARCH on [ FGristFiles $(strlSources) strnlen.c ]
+SEARCH on [ FGristFiles $(strlSources) ]
 	= [ FDirName $(HAIKU_TOP) src system libroot posix string ] ;
 SEARCH on [ FGristFiles KMessage.cpp ]
     = [ FDirName $(HAIKU_TOP) src system kernel messaging ] ;
